# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""Utility module for proxy.

Define class for proxy XML data.
"""

import urlparse


PROXY_NAME = "proxy"
SERVER_PATH = "serverlist/server"
PROXY_HOST_PATH = SERVER_PATH + "/host"
PROXY_PORT_PATH = SERVER_PATH + "/port"

HTTP_PROTOCOL = "http"
HTTPS_PROTOCOL = "https"


class ProxyInfo(object):
    """Class for proxy information."""

    def __init__(self, proxy_xml):
        """Constructor."""

        self.host = proxy_xml.get_value(PROXY_HOST_PATH, None)
        self.port = proxy_xml.get_value(PROXY_PORT_PATH, None)

        self.host_port = self.host
        if self.host and self.port:
            self.host_port += ":" + self.port

    def get_proxy_url(self, protocol):
        """Return proxy url."""

        return urlparse.urlunparse((protocol, self.host_port, "", "", "", ""))
